#include "MotorExpert.h"
#include "msg.h"

#include <iostream>

int needodo=0;

// la parola extern non dichiara un nuovo identificatore, 
// ma dice "La variabile intera a e` dichiarata da qualche altra parte, 
// lascia solo lo spazio per risolvere il riferimento"

extern void motorlex_memory(const char* src, MotorExpert* pMotor);
extern int MessageLineNum;

MotorExpert::MotorExpert(ModuleDispatch* kernel, int period, Spykee *s ) : StringModuleMember( kernel, period, "motor" ){
	spykee = s;
	m_opt = 4;

	printf( "\nMotorExpert (Spykee edition) build" );
	fflush(stdout);
}

MotorExpert::~MotorExpert()
{
  printf("\nMotorExpert destroyed");
  fflush(stdout);
};

void MotorExpert::RunInit()
{
	settimer(0);
	settimer(1);
	settimer(2);
	settimer(3);

	m_opt = 4;
	
  AddMessageRequest( MSG_TO_MOTION,LOCAL );
  
 // SetWheelDistance(350);
 // SetConversionCoefficients(0.0333,-0.0333);
  
  printf("\nMotorExpert initialized");
  fflush(stdout);
};

/* ***********************************
   
   DoYourDuty()

   *********************************** */

void MotorExpert::RunDuty()
{
	float Tan,Rot;
	int flag=0;

	//printf("sono motor\n");
	
  // ************************************************************
  //  Se c'e' un messaggio da parte del controllo di alto livello, 
  //  cambio i setpoint, altrimenti cerco di mantenerli
  // ************************************************************


  unsigned char* buffer;
  if(ReceiveLastMessage(MSG_TO_MOTION, buffer,true) > 0){
		
		struct timeval now;
		//printf("%d\n",elapsed(2));
		if(elapsed(1)<100000){
			return;
		}else{
			gettimeofday(&now, NULL);
			//printf("*****************nuovo comando: %d *      %d %d\n",elapsed(1),now.tv_sec,now.tv_usec);
			settimer(1);
			settimer(2);
		}
	//printf("*\n");
	
		int i;
		float n;

		for( i = 0; buffer[i] != NULL; i++ );
		char* buf=(char*)malloc(i+1);
   		strcpy(buf,(char*)buffer);

		int dxSpeed = 0;
		int sxSpeed = 0;
		int tanSpeed = 0;
		int rotSpeed = 0;

		if ( strtovalue( buf, "TanSpeed ", &n ) )
			tanSpeed = (int)n;

		if ( strtovalue( buf, "RotSpeed ", &n ) )
			rotSpeed = (int)n;

		if ( strtovalue( buf, "MovingFlag ", &n ) )
			m_opt = (int)n;

		dxSpeed = tanSpeed - rotSpeed;
		sxSpeed = tanSpeed + rotSpeed;

		printf( "Motor: sx: %d dx: %d\t %d\n", sxSpeed, dxSpeed, m_opt );
		
		if (dxSpeed > 80)
			dxSpeed = 80;
		if (sxSpeed > 80)
			sxSpeed = 80;
		if (dxSpeed < -80)
			dxSpeed = -80;
		if (sxSpeed < -80)
			sxSpeed = -80;

		switch ( m_opt ){
			case SX90:
			case DX90:
				if ( elapsed(3) < 1000000 )				// 1 sec
					return;
				else
					ResetMoving();
				break;
			case SX180:
//			case DX180:
				if ( elapsed(3) < 2000000 )				// 2 sec
					return;
				else
					ResetMoving();
				break;
			default:
				ResetMoving();
		}

		if ( spykee )		
			spykee->move(dxSpeed, sxSpeed);
		else {
			printf( "Motion: Spykee not connected!\n" );
			printf( "        sx: %d\tdx: %d\n", sxSpeed, dxSpeed );
		} 

		NewMessage(MSG_FROM_MOTION,MOTION_DATA);
		AddOdometryData("TANSPEED", (int) tanSpeed);
		AddOdometryData("ROTSPEED", (int) rotSpeed);
		CloseMessage();
		SendAllStringMessages();	
	}
};

void MotorExpert::RunClose()
{
  printf("\nMotorExpert closed");
  fflush(stdout);
};


void MotorExpert::SendMotorMessage()
{
 /* NewMessage(MSG_FROM_MOTION,MOTION_DATA);
  FloatDataListType::iterator it;
  for (it = mOdometryData.begin(); it != mOdometryData.end(); it++)
    {
      AddOdometryData(it->first,it->second);
    } 
  //cout << mCurrentMessage.str()<<endl;   //*wiim*
  SendAllStringMessages();*/
}

void MotorExpert::AddOdometryData(string name, float value)
{
  mCurrentMessage << "<E>" << name << " " << value << "</E>\n";    
}

void MotorExpert::ResetMoving(){
	NewMessage(MSG_TO_BRIAN, MOTION_DATA );
	mCurrentMessage << "<D>MovingFlag " << STOP << " " << 1 << "</D>\n";
	CloseCurrentMessage();
	SendAllStringMessages();
	m_opt = 4;
	settimer(3);
}

long MotorExpert::elapsed(int i)
{ 
	struct timeval now;
	long elapsed_usec = 0;

	gettimeofday(&now, NULL);


	if (now.tv_usec > 1000000) {
		now.tv_usec -= 1000000;
		++now.tv_sec;
	}

	if (now.tv_sec > last_render[i].tv_sec){
		elapsed_usec = ((now.tv_sec - last_render[i].tv_sec) * 1000000);
	}

	if (now.tv_usec > last_render[i].tv_usec)
		elapsed_usec += now.tv_usec - last_render[i].tv_usec;
	else
		elapsed_usec -= last_render[i].tv_usec - now.tv_usec;


	return elapsed_usec ;

}

void MotorExpert::settimer(int i)
{
	gettimeofday(&(last_render[i]),NULL);
	return;
}
